#property link      "http://www.themovingaverage.com"
#property indicator_chart_window

//   2010-02-02 Vinin
//        

#property indicator_buffers 6
#property indicator_color1 Yellow
#property indicator_color2 MediumAquamarine
#property indicator_color3 Red
#property indicator_color4 LimeGreen
#property indicator_color5 Red
#property indicator_color6 LimeGreen


extern int firstback=50;
extern int secondback=14;
extern int countbars=2000;
extern int power=2;


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];

int init()
  {
   SetIndexStyle(0,DRAW_LINE); SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE); SetIndexBuffer(1,ExtMapBuffer2);
   

   SetIndexStyle(2,DRAW_LINE); SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE); SetIndexBuffer(3,ExtMapBuffer4);

   SetIndexStyle(4,DRAW_LINE); SetIndexBuffer(4,ExtMapBuffer5); 
   SetIndexStyle(5,DRAW_LINE); SetIndexBuffer(5,ExtMapBuffer6); 

   return(0);
  }
int deinit()
  {
   return(0);
  }
int last = 0;

int start(){
   int counted_bars=IndicatorCounted();
   int pos=Bars-counted_bars-1;
   if (counted_bars==0) pos=Bars-MathMax(firstback,secondback)-1;
   if (pos>countbars && countbars>0) pos=countbars;
   while (pos>-1){
      
      ExtMapBuffer1[pos] = MA(firstback,  pos);
      ExtMapBuffer2[pos] = MA(secondback, pos);
      ExtMapBuffer3[pos] = EMPTY_VALUE;
      ExtMapBuffer4[pos] = EMPTY_VALUE;
      ExtMapBuffer5[pos] = EMPTY_VALUE;
      ExtMapBuffer6[pos] = EMPTY_VALUE;

      if((ExtMapBuffer2[pos]-ExtMapBuffer1[pos])< 0) {
         ExtMapBuffer3[pos]  = ExtMapBuffer1[pos];
         ExtMapBuffer3[pos+1]= ExtMapBuffer1[pos+1];
         ExtMapBuffer5[pos]  = ExtMapBuffer2[pos];
         ExtMapBuffer5[pos+1]= ExtMapBuffer2[pos+1];

      } else {
         ExtMapBuffer4[pos]  = ExtMapBuffer1[pos];
         ExtMapBuffer4[pos+1]= ExtMapBuffer1[pos+1];
         ExtMapBuffer6[pos]  = ExtMapBuffer2[pos];
         ExtMapBuffer6[pos+1]= ExtMapBuffer2[pos+1];

      }
      pos--;
   }
   return(0);
  }

double MA(int period, int pos){
   int cnt, mult;
   double first=0;
   double second=0;
   double tmp;
   mult=period;
   for (cnt=pos; cnt<pos+period; cnt++, mult--){
      tmp=MathPow(mult,power);
      first+=Close[cnt]*tmp;
      second+=tmp;
   }
   if (second>0) return(first/second);
   return(EMPTY_VALUE);
}